clear all
rng(1); % new way to control random number generation

case_name = 'Case4';

%% Case with a 2 sites GMDP
GMDP.M=[2 3];
GMDP.B=[3 2];
GMDP.G=[1 1;1 1];

n = 2; % number of site
for i=1:n
    N{i} = find(GMDP.G(:,i))'; % vector of neighbors
    SN(i) = prod(GMDP.M(N{i}));  % number of states for the neighbors
end

for i=1:n
    GMDP.Ploc{i} = zeros(SN(i),GMDP.M(i),GMDP.B(i));
    GMDP.Rloc{i} = zeros(SN(i),GMDP.B(i));
    for a=1:GMDP.B(i)
        GMDP.Ploc{i}(:,:,a)=rand(SN(i),GMDP.M(i));
        GMDP.Ploc{i}(:,:,a)=GMDP.Ploc{i}(:,:,a)./repmat(sum(GMDP.Ploc{i}(:,:,a),2),1,GMDP.M(i));
        GMDP.Rloc{i}(:,a) = a*[1:SN(i)]';
    end
end

discount=0.85;

%% Test 1 - Test gmdp_globalize
P1(:,:,1) = [
    0.3782    0.1545    0.1585    0.1689    0.0690    0.0708
    0.3216    0.3041    0.0501    0.1543    0.1459    0.0240
    0.0000    0.0002    0.0000    0.1298    0.7325    0.1374
    0.1437    0.0858    0.1300    0.2560    0.1529    0.2317
    0.1216    0.1117    0.0260    0.3473    0.3191    0.0743
    0.0680    0.0267    0.0241    0.5043    0.1979    0.1790 ];
P1(:,:,2) = [
    0.2702    0.0562    0.3648    0.1207    0.0251    0.1630
    0.0367    0.2849    0.3542    0.0176    0.1367    0.1699
    0.0001    0.0001    0.0001    0.2593    0.3137    0.4267
    0.0460    0.1297    0.1837    0.0819    0.2312    0.3274
    0.0991    0.0084    0.1519    0.2829    0.0240    0.4338
    0.0605    0.0463    0.0119    0.4491    0.3439    0.0882 ];
P1(:,:,3) = [
    0.3244    0.1325    0.1360    0.2227    0.0910    0.0934
    0.3883    0.3672    0.0605    0.0876    0.0828    0.0136
    0.0043    0.0242    0.0045    0.1255    0.7085    0.1329
    0.1635    0.0976    0.1480    0.2362    0.1410    0.2137
    0.2678    0.2460    0.0573    0.2011    0.1848    0.0430
    0.2556    0.1003    0.0907    0.3167    0.1243    0.1124 ];
P1(:,:,4) = [
    0.2317    0.0482    0.3129    0.1591    0.0331    0.2149
    0.0443    0.3439    0.4277    0.0100    0.0776    0.0965
    0.0086    0.0104    0.0141    0.2508    0.3034    0.4127
    0.0523    0.1477    0.2091    0.0756    0.2133    0.3020
    0.2182    0.0185    0.3344    0.1638    0.0139    0.2512
    0.2276    0.1743    0.0447    0.2820    0.2160    0.0554 ];
P1(:,:,5) = [
    0.4919    0.2010    0.2062    0.0552    0.0226    0.0231
    0.3236    0.3060    0.0504    0.1523    0.1440    0.0237
    0.0106    0.0597    0.0112    0.1192    0.6730    0.1263
    0.0273    0.0163    0.0247    0.3724    0.2224    0.3370
    0.0924    0.0849    0.0198    0.3765    0.3459    0.0806
    0.4210    0.1652    0.1494    0.1513    0.0594    0.0537 ];
P1(:,:,6) = [
    0.3514    0.0732    0.4745    0.0394    0.0082    0.0533
    0.0369    0.2866    0.3564    0.0174    0.1349    0.1678
    0.0212    0.0256    0.0348    0.2383    0.2882    0.3920
    0.0087    0.0246    0.0349    0.1191    0.3363    0.4763
    0.0753    0.0064    0.1154    0.3067    0.0260    0.4702
    0.3749    0.2871    0.0737    0.1347    0.1032    0.0265 ];
R1 = [
     2     3     3     4     4     5
     4     6     6     8     8    10
     6     9     9    12    12    15
     8    12    12    16    16    20
    10    15    15    20    20    25
    12    18    18    24    24    30 ];


%% Test 2 - Test gmdp_eval_policy_MF with default arguments
Vloc2{1} = [ 21.3617   22.1639   23.3227   25.0629   25.8651   27.0239 ]';
Vloc2{2} = [ 21.3617   22.1639   23.3227   25.0629   25.8651   27.0239 ]';


%% Test 3 - Test gmdp_eval_policy_MF with different policyloc and Qloc0
Vloc3{1} = [ 69.0192   71.6828   73.5655   76.7558   79.4193   81.3021 ]';
Vloc3{2} = [ 46.0128   47.7885   49.0437   51.1706   52.9462   54.2014 ]';


%% Test 4 - Test gmdp_eval_policy_MF with different policyloc, Qloc0 and Tend
Vloc4{1} = [ 9.7860   13.3631   17.5440   20.3949   17.9098   27.1003 ]';
Vloc4{2} = [ 5.3309    6.2888   11.3511    8.6848   14.6795   17.7686 ]';


%% Test 5 - Test gmdp_policy_iteration_MF with default arguments
Vloc5{1}=[ 67.9551   72.1359   74.1560   78.8721   82.0488   84.0856 ]';
Vloc5{2}=[ 46.4294   48.5404   49.9222   53.0237   55.1347   56.5165 ]';
policyloc5{1}=[ 2     3     3     3     3     3 ]';
policyloc5{2}=[ 2     2     2     2     2     2 ]';
iter5 = 2;


%% Test 6 - Test gmdp_policy_iteration_MF with different policyloc, max_iter and max_iter_update
policyloc6{1}=[ 2     3     3     3     3     3 ]';
policyloc6{2}=[ 2     2     2     2     2     2 ]';
Vloc6{1}=[ 67.9551   72.1359   74.1560   78.8721   82.0488   84.0856 ]';
Vloc6{2}=[ 46.4294   48.5404   49.9222   53.0237   55.1347   56.5165 ]';
iter6=2;


%% Test 7 - Test gmdp_linear_programming
policyloc7{1}=[ 2     3     3     3     3     3 ]';
policyloc7{2}=[ 2     2     2     2     2     2 ]';
